/* UsiFe FileSystem
----------------
Copyright (2012): Rohan Sharma and Saurabh Kumar

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

CONTACT: 
Rohan Sharma : rickyrohan14@gmail.com
Saurabh Kumar : saurabh.catch@gmail.com
Smruti R. Sarangi : srsarangi@cse.iitd.ac.in
*/
#include "fuse_include.h" 
#include "aes.h"

int generate_key (char *key,char *iv)
{
	int i, j, fd;
	if ((fd = open ("/dev/random", O_RDONLY)) == -1)
		perror ("open error");

	if ((read (fd, key, 32)) == -1)
		perror ("read key error");

	if ((read (fd, iv, 32)) == -1)
		perror ("read iv error");
	
	DEBUG_PRINTF("256 bit key:\n");
	for (i = 0; i < 32; i++)
		DEBUG_PRINTF("%d \t", key[i]);
	DEBUG_PRINTF ("\n ------ \n");

	DEBUG_PRINTF("Initialization vector\n");
	for (i = 0; i < 32; i++)
		DEBUG_PRINTF ("%d \t", iv[i]);

	DEBUG_PRINTF ("\n ------ \n");
	close (fd);
	return 0;
}

void getkey(char *key,char *val)
{
int i=0;
char c[3]="aa";
char *end;
char c1[2];

 for(i=0;i<64;i+=2)
  {
   fflush(stdout);
   c[0]=val[i];
  
   c[1]=val[i+1];
   key[i/2]=(char)strtol(c,&end,16);
   DEBUG_PRINTF("abcd %d  %d %d\n",i,val[i],key[i/2]);
   
  } 
}


int aes_init(unsigned char *key_data, int key_data_len, unsigned char *salt, EVP_CIPHER_CTX *e_ctx,EVP_CIPHER_CTX *d_ctx)
{
  int i=0, nrounds = 5;
  unsigned char key[32], iv[32];
  char *val="000102030405060708090A0B0C0D0E0F000102030405060708090A0B0C0D0E0F",*end;
  int result;

  
  result=(int)strtol("FF",&end,16);
  DEBUG_PRINTF("KEY %d %d\n\n",result,strlen(val));
  fflush(stdout);

  getkey(key,val);
  getkey(iv ,val);

  DEBUG_PRINTF("Key");
  for(i=0;i<32;i++)
  {
   DEBUG_PRINTF("   %d ",key[i]);

  }
  DEBUG_PRINTF("iv");
  for(i=0;i<32;i++)
  {
   DEBUG_PRINTF("   %d ",iv[i]);

  }
  
  
  EVP_CIPHER_CTX_init(e_ctx);
  EVP_EncryptInit_ex(e_ctx, EVP_aes_256_cbc(), NULL, key, iv);
  
  EVP_CIPHER_CTX_init(d_ctx);
  EVP_DecryptInit_ex(d_ctx, EVP_aes_256_cbc(), NULL, key, iv);
  return 0;
}



/*
 * Encrypt *len bytes of data
 * All data going in & out is considered binary (unsigned char[])
 */
unsigned char *aes_encrypt(EVP_CIPHER_CTX *e, unsigned char *plaintext, int *len)
{
  /* max ciphertext len for a n bytes of plaintext is n + AES_BLOCK_SIZE -1 bytes */
  int c_len = *len + AES_BLOCK_SIZE, f_len = 0;
  unsigned char *ciphertext = malloc(c_len);
  DEBUG_PRINTF("Length %d\n",*len);
 
  /* allows reusing of 'e' for multiple encryption cycles */
  EVP_EncryptInit_ex(e, NULL, NULL, NULL, NULL);  
  /* update ciphertext, c_len is filled with the length of ciphertext generated,
    *len is the size of plaintext in bytes */
  EVP_EncryptUpdate(e, ciphertext, &c_len, plaintext, *len);
  DEBUG_PRINTF("update %d\n",c_len);
 

  /* update ciphertext with the final remaining bytes  (not required if data is multiple of block size 16 bytes) */

  DEBUG_PRINTF("final %d\n",f_len);
   
 
 *len = c_len + f_len;
  return ciphertext;
}

/*
 * Decrypt *len bytes of ciphertext
 */
unsigned char *aes_decrypt(EVP_CIPHER_CTX *e, unsigned char *ciphertext, int *len)
{
  /* plaintext will always be equal to or lesser than length of ciphertext*/
  int p_len = *len, f_len = 0;
  unsigned char *plaintext = malloc(p_len);
  
  EVP_DecryptInit_ex(e, NULL, NULL, NULL, NULL);
  EVP_DecryptUpdate(e, plaintext, &p_len, ciphertext, *len);
  //EVP_DecryptFinal_ex(e, plaintext+p_len, &f_len);

  *len = p_len + f_len;
  return plaintext;
}



int aes_main()
{
  /* encryption, decryption ctx structures that libcrypto uses to record
   * status of enc/dec operations 
   */
  EVP_CIPHER_CTX en, de;

  /* 8 bytes to salt the key_data during key generation. 
   */
  unsigned int salt[] = {12345, 54321};
  unsigned char *key_data;
  int key_data_len, i;

  /* 
   * Change input with your own data.
   */
  
  char *input[] = {"123456789012345 123456789012345", "abcd", "this is a test", "this is a bigger test",     
                   NULL};

  /* 
   * gen key and iv. init the cipher ctx object 
   */
  
  if (aes_init(key_data, key_data_len, (unsigned char *)&salt, &en, &de)) {
    DEBUG_PRINTF("Couldn't initialize AES \n");
    return -1;
  }

  /* 
   * encrypt and decrypt each input string and compare with the original 
   */
  for (i = 0; input[i]; i++) {
    
    char *plaintext;
    unsigned char *ciphertext;
    int olen, len;
    
    /* The enc/dec functions deal with binary data and not C strings. strlen() will 
     * return length of the string without counting the '\0' string marker. 
     */
    olen = len = strlen(input[i])+1;
    
    ciphertext = aes_encrypt(&en, (unsigned char *)input[i], &len);
    
    plaintext = (char *)aes_decrypt(&de, ciphertext, &len);
    
  

    if (strncmp(plaintext, input[i], olen)) 
      DEBUG_PRINTF("FAIL: enc/dec failed for \"%s  \"   %s\n  ", input[i],plaintext);
    else 
      DEBUG_PRINTF("OK: enc/dec ok for \"%s\"\n", plaintext);
    
    free(ciphertext);
    free(plaintext);
  }

  EVP_CIPHER_CTX_cleanup(&en);
  EVP_CIPHER_CTX_cleanup(&de);

  return 0;
}
  

