/* UsiFe FileSystem
----------------
Copyright (2012): Rohan Sharma and Saurabh Kumar

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

CONTACT: 
Rohan Sharma : rickyrohan14@gmail.com
Saurabh Kumar : saurabh.catch@gmail.com
Smruti R. Sarangi : srsarangi@cse.iitd.ac.in
*/
#include "fuse_include.h" 
#include "alloc.h"

blk_t alloc_block()
{  
   ext2_filsys e2fs=(ext2_filsys)current_ext2fs();
   blk_t ret;
   char data[4096];
   memset(data,0,4096);  
   DEBUG_PRINTF("allocating new block\n");

   /* 
    * Allocate new block
    */ 
   ext2fs_alloc_block(e2fs, 0,0, &ret);
   DEBUG_PRINTF("Allocated block # %d\n",ret);
  
   DEBUG_PRINTF("Setting all bits to zero\n");
   
   /* 
    * Zero out data on allocated block
    */  
   io_channel_write_blk(e2fs->io, ret, 1,data);

   DEBUG_PRINTF("Done set to zero\n");
   return ret; 
}


