/* UsiFe FileSystem
----------------
Copyright (2012): Rohan Sharma and Saurabh Kumar

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

CONTACT: 
Rohan Sharma : rickyrohan14@gmail.com
Saurabh Kumar : saurabh.catch@gmail.com
Smruti R. Sarangi : srsarangi@cse.iitd.ac.in
*/
#include "fuse_include.h"
#include "do_init.h"


void* do_init(struct fuse_conn_info *conn){
   
    ext2_filsys e2fs;
    int i=0;
    pthread_t p;
    DEBUG_PRINTF("opening filesystem\n");
    fflush(stdout);
    
    DEBUG_PRINTF("Initializing key\n");
    for(i=0;i<=4095;i++)
        key[i]='!';

    struct fuse_context *cntx=fuse_get_context();
    struct extfs_data *e2data=cntx->private_data;

    /* 
     * This thread handles gtk GUI.
     */ 	
    pthread_create(&p,NULL,callmain,NULL);    
    
    /* 
     * Initialize mutex variables.
     */ 	 	 
    pthread_mutex_init(&mutex,NULL);            
    pthread_mutex_init(&mutexr,NULL);
    pthread_mutex_init(&change,NULL);
    pthread_mutex_init(&mutex2,NULL);  
    pthread_mutex_init(&write_mutex,NULL);  
    pthread_mutex_init(&read_inode_mutex,NULL);  
    pthread_mutex_init(&judy_mutex,NULL);  	

    int a=ext2fs_open("CentOS" ,EXT2_FLAG_RW,0, 0, unix_io_manager, &e2data->e2fs);
    if(!a)
      DEBUG_PRINTF("OPEN SUCCESSFUL \n");
    

       a = ext2fs_read_bitmaps(e2data->e2fs);
	if (a) {
		DEBUG_PRINTF("Error while reading bitmaps\n");
		ext2fs_close(e2data->e2fs);
		exit(1);
	}

   ext_fs=e2data->e2fs;
   fflush(stdout);
   
   return  e2data; 

}


void* callmain(){
 /* 
  * Call gtk main to start GUI.
  */ 	
    
 gtk_main();

}
