/* UsiFe FileSystem
----------------
Copyright (2012): Rohan Sharma and Saurabh Kumar

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

CONTACT: 
Rohan Sharma : rickyrohan14@gmail.com
Saurabh Kumar : saurabh.catch@gmail.com
Smruti R. Sarangi : srsarangi@cse.iitd.ac.in
*/
#include "fuse_include.h"
#include "other.h"
#include "do_open.h"


int do_open(const char *path, struct fuse_file_info *fi)
  {
    ext2_ino_t ino;
    struct ext2_inode inode;
    ext2_filsys e2fs = current_ext2fs();
    
    int rt = do_readinode(e2fs,path, &ino, &inode);
    if(rt)
      { 
        DEBUG_PRINTF("failed to read inode %s\n",path);
        return -ENOENT; 
      }

    ext2_file_t efile;
    rt = ext2fs_file_open2(e2fs, ino, &inode,
			(((fi->flags & O_ACCMODE) != 0) ? EXT2_FILE_WRITE : 0), 
			&efile);
    fflush(stdout);

    if(rt)
       { 
        DEBUG_PRINTF("failed to open file %s\n",path);
        return -ENOENT; 
       }

   pthread_mutex_lock(&mutex2); 
   fi->fh=(unsigned long)efile;/*add file handle to file info*/
   pthread_mutex_unlock(&mutex2);  
    
   return 0;
  } 

