/* UsiFe FileSystem
----------------
Copyright (2012): Rohan Sharma and Saurabh Kumar

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

CONTACT: 
Rohan Sharma : rickyrohan14@gmail.com
Saurabh Kumar : saurabh.catch@gmail.com
Smruti R. Sarangi : srsarangi@cse.iitd.ac.in
*/
#include "fuse_include.h"
#include "other.h"
#include "do_readdir.h"

int walk_dir (struct ext2_dir_entry *de, int offset, int blocksize, char *buf, void *priv_data)
{
	int ret;
	size_t flen;
	char *fname;
	struct dir_walk_data *b = priv_data;
	
	flen = de->name_len&0x00ff;
	fname = (char *) malloc(sizeof(char) * (flen +1));
	if (fname == NULL) {
		DEBUG_PRINTF("s = (char *) malloc(sizeof(char) * (%d + 1)); failed", flen);
		return -ENOMEM;
	}
	snprintf(fname, flen+1 , "%s", de->name);
	DEBUG_PRINTF("%s\n",fname);

        pthread_mutex_lock(&mutexr);
        ret = b->filler(b->buf, fname, NULL, 0);
	pthread_mutex_unlock(&mutexr);
        free(fname);
	
	return ret;
}

int do_readdir(const char *path, void *buf, fuse_fill_dir_t filler,off_t offset, struct fuse_file_info *fi)
{

   ext2_ino_t ino;
   struct ext2_inode inode;
   struct dir_walk_data dwd={
		.buf = buf,
		.filler = filler};
   ext2_filsys e2fs = current_ext2fs();

   if(1) {

   int rt = do_readinode(e2fs,path, &ino, &inode);
	if (rt) {
		DEBUG_PRINTF("do_readinode %s failed\n",path);
		return rt;
	}
   int  rc = ext2fs_dir_iterate(e2fs, ino, 0, NULL, walk_dir,&dwd);

	if (rc) {
		DEBUG_PRINTF("Error while trying to ext2fs_dir_iterate %s ",path);
		return -EIO;
	}
        return 0; 
    }
    
   else
    return -ENOENT;
   
}
