/* UsiFe FileSystem
----------------
Copyright (2012): Rohan Sharma and Saurabh Kumar

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

CONTACT: 
Rohan Sharma : rickyrohan14@gmail.com
Saurabh Kumar : saurabh.catch@gmail.com
Smruti R. Sarangi : srsarangi@cse.iitd.ac.in
*/
/* 
 * This functions opens a file for reading or writing and returns a file handle.
 * This function is not called by fuse.
 * Returns file handle if succeeded else returns NULL.
 */ 
ext2_file_t do_open2 (ext2_filsys e2fs, const char *path, int flags);

/* 
 * This functions reads an inode corresponding to the file name given by path, and fills inode structure and inode number in ino.
 * Returns zero if succeeded else returns error.
 */ 
int do_readinode (ext2_filsys e2fs, const char *path, ext2_ino_t *ino, struct ext2_inode *inode);


/* 
 * Reads the current filesystem opened by fuse and returns ext2_filsys.
 * 
 */ 
ext2_filsys current_ext2fs(void);

/* 
 * This function performs encryption of data starting at byte offset start.
 * It performs encryption by taking xor of every integer with a constant character.
 */ 
void simple_encryption(const char *in,int start,int size,char *out);

int do_utimens (const char *path, const struct timespec tv[2]);

int do_chmod (const char *path, mode_t mode);

int do_chown (const char *path, uid_t uid, gid_t gid);
