/* UsiFe FileSystem
----------------
Copyright (2012): Rohan Sharma and Saurabh Kumar

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

CONTACT: 
Rohan Sharma : rickyrohan14@gmail.com
Saurabh Kumar : saurabh.catch@gmail.com
Smruti R. Sarangi : srsarangi@cse.iitd.ac.in
*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "usife.h"

int main()
{
 
 int enc=1;
 char *path="../FileSystem/Mount/test";
 int fd=usife_open(path,O_RDWR|O_CREAT);
 char write_buf[10]="abcdSECRET";
 char buf[100]="";
 int write,read;	
 int off1=4,off2=8;

//write abcd in normal form and SECRET in encrypted form.
 if(fd<0) 
  { 
  printf("Open failed\n");
  exit(-1);
  }
//write abcd
 if(usife_set_encryption(path,0)<0)
  {
    printf("Encryption mode set failed\n");
    exit(-1);  
  }
 write=usife_write(fd,write_buf,off1);

 if(write<0)
  {
  printf("Write failed\n");
  exit(-1);
  }
  else
  {
  printf("bytes written %d\n",write);
  }

//write SECRET
 if(usife_set_encryption(path,1)<0)
  {
    printf("Encryption mode set failed\n");
    exit(-1);  
  }
 write=usife_write(fd,write_buf+off1,off2-off1);

 if(write<0)
  {
  printf("Write failed\n");
  exit(-1);
  }
  else
  {
  printf("bytes written %d\n",write);
  }
//write part2 
 if(usife_set_encryption(path,0)<0)
  {
    printf("Encryption mode set failed\n");
    exit(-1);  
  }
 write=usife_write(fd,write_buf+off2,10-off2);

 if(write<0)
  {
  printf("Write failed\n");
  exit(-1);
  }
  else
  {
  printf("bytes written %d\n",write);
  }
 
  //write part3
  if(usife_set_encryption(path,1)<0)
  {
    printf("Encryption mode set failed\n");
    exit(-1);  
  }
 write=usife_write(fd,write_buf,off1);

 if(write<0)
  {
  printf("Write failed\n");
  exit(-1);
  }
  else
  {
  printf("bytes written %d\n",write);
  }

 if(usife_close(fd)<0)
  printf("Close failed");


//read
 int j=0;
 for(;j<3;j++)
 {

 fd=usife_open(path,O_RDWR);
	
 if(usife_set_readmode(path,j)<0)
  {
  printf("Read mode set failed\n");
  exit(-1);
  }
 read=usife_read(fd,buf,4096);
 if(read<0)
  {
  printf("Read failed\n");
  exit(-1);
  }
 else
  {
   int i=0;
   printf("READ MODE %d ,%d :",j,read);
   for(;i<read;i++)
    printf("%c ",buf[i]);  
   printf("\n");
  } 	
 if(usife_close(fd)<0)
  printf("Close failed");
 }

//read encrypted blocks
char data[4096];

/*
int b_read=usife_read_enc_block(path,"0",data,4096);
printf("\nenc block read %d :",b_read);
   for(j=0;j<b_read;j++)
    printf("%d ",data[j]);  
*/ 
}

