#! /usr/bin/env python

# UsiFe FileSystem
#----------------
#Copyright (2012): Rohan Sharma and Saurabh Kumar
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#CONTACT: 
#Rohan Sharma : rickyrohan14@gmail.com
#Saurabh Kumar : saurabh.catch@gmail.com
#Smruti R. Sarangi : srsarangi@cse.iitd.ac.in

import sys
import commands
import struct
import xattr
import tempfile
import shutil
import os
import zipfile


#find file filesystems 
def filesystem(path):
    fs=commands.getoutput('df '+path).split("\n")[1].split()[0];	
    return fs

#copy file from usife file system to some other file system
def copy_out(path,dst):
    print "changing read mode to 2\n"
    xattr.setxattr(path,"Read",struct.pack("i",2));
    print "copying file\n"
    fd1, temp1_path = tempfile.mkstemp()
    print "creating temp file "+temp1_path+"\n"
    
    fd0 = open(path,"r");
    
    while 1:
        out=fd0.read(4096);
        if(out==""):#reached end of file
           os.close(fd1)
           fd0.close()
           break
        print out    
        os.write(fd1,out)#assuming all bytes are written

    print "copying enc regions\n"
    fd2, temp2_path = tempfile.mkstemp()
    print "creating temp file "+temp2_path+"\n" 

    i=0;
    while 1:
        out=xattr.getxattr(path,str(i))
        if(out==""):
            os.close(fd2)
            break
        print "Length :" +str(len(out))+"\n" 
        index=struct.unpack('h',out[0:2])
        print "index "+ str(index[0])+"\n"
        j=0;
        loop=index[0]
        if(index[0]==511):
          loop=510
        while(j<loop):
            region=struct.unpack('IHH',out[2+j*8:2+j*8+8])
            print "block: "+str(region[0])+", start: "+str(region[1])+", end: "+str(region[2])
            start=(region[0]-1)*4096+region[1]-1;
            end=(region[0]-1)*4096+region[2]-1;
            os.write(fd2,str(start)+","+str(end)+"\n")#assuming all bytes are written
            j=j+1;

        if(index[0]!=511):
          os.close(fd2)  
          break
        i=i+1 

    # open the zip file for writing, and write stuff to it
    print "Creating zip file: "+os.path.abspath(dst)+"/"+os.path.basename(path)+".zip.usife"
    file = zipfile.ZipFile(os.path.abspath(dst)+"/"+os.path.basename(path)+".zip.usife", "w")
    file.write(temp1_path,"data", zipfile.ZIP_DEFLATED)
    file.write(temp2_path,"enc", zipfile.ZIP_DEFLATED)
    file.close()
 
    os.remove(temp1_path)
    os.remove(temp2_path)

    return;

#copy file in usife format from some other file system to usife
def copy_in(path,dst):

    zfile = zipfile.ZipFile(path, "r")
    print "Usife File contents:"       
    for name in zfile.namelist():
       print "  "+name+":"
       if(name=="data" or name=="enc"):
          print "    accepted"
       else:
          sys.exit("    unidentified file") 

    fd0=zfile.open("data","r")
    fd1=zfile.open("enc","r")

    size0=zfile.getinfo("data").file_size

    print "Data Size : "+ str(size0)

    print "Encrypted regions"

    last_end=-1;
    while 1:
      sr=fd1.readline().split(",")
      if(sr[0]==""):
        break
      print sr[0]+" ,"+sr[1];

      if(int(sr[0])<=last_end):
         zfile.close()
         sys.exit("Corrupt encrypted regions..")

      if((int(sr[0])>int(sr[1]))):
         zfile.close()
         sys.exit("Corrupt encrypted regions,,")

      if((int(sr[1]))>(size0-1)):
         zfile.close()
         sys.exit("Corrupt encrypted regions;;")

      last_end=int(sr[1])

    fd1=zfile.open("enc","r")#reopen the file

    print "opening output file :"+os.path.abspath(dst)+"/"+os.path.basename(path).split(".")[0];
    fd2=open(os.path.abspath(dst)+"/"+os.path.basename(path).split(".")[0],"w");
    finalpath=os.path.abspath(dst)+"/"+os.path.basename(path).split(".")[0];
    last_end=-1;
    off=0; #file offset    

    while 1:
      sr=fd1.readline().split(",")
      if(sr[0]==""):
        print "No more encrypted regions available"
        xattr.setxattr(finalpath,"Enc",struct.pack("i",0));#turn encryption off
        while 1:
            out=fd0.read(min(size0-off,4096));
            if(out==""):#reached end of file
                  fd2.close()
                  zfile.close()
                  break
            off=off-len(out)
            print "Read :"+str(len(out))
            fd2.write(out) #assuming all bytes are written  
            fd2.flush()
            if(off==0):
                  fd2.close()
                  zfile.close()
                  break;
        break

      enc_start=int(sr[0])
      enc_end=int(sr[1])

      if(enc_start<=last_end):
         fd2.close()
         zfile.close()
         sys.exit("Error in encrypted regions..")
         
      if(enc_start > enc_end):
         fd2.close()
         zfile.close()
         sys.exit("Error in encrypted regions,,")

      if(enc_end > size0-1):
         fd2.close()
         zfile.close()
         sys.exit("Error in encrypted regions;;")

         
      print(str(enc_start)+" "+str(enc_end))

      if(enc_start-off>0): #write plain region
         print "Writing plain region : Start "+ str(off)+" end "+str(enc_start-1)
         xattr.setxattr(finalpath,"Enc",struct.pack("i",0));#turn encryption off
         bytes=enc_start-off
         while 1:
            out=fd0.read(min(enc_start-off,4096));
            if(out==""):#reached end of file
                  fd2.close()
                  zfile.close()
                  sys.exit("Reached unexpected end of file while reading,,,,")
            bytes=bytes-len(out)
            print "Read :"+str(len(out))
            fd2.write(out) #assuming all bytes are written
            fd2.flush()  
            if(bytes==0):
                  break;
         off=off+enc_start-off;  

      ##now write encrypted regions
      xattr.setxattr(finalpath,"Enc",struct.pack("i",1));#turn encryption on
      print "Writing encrypted region : Start "+ str(enc_start)+" end "+str(enc_end)
      bytes=enc_end-enc_start+1;
      while 1:
         out=fd0.read(min(bytes,4096));
         if(out==""):#reached end of file
            fd2.close()
            zfile.close()
            sys.exit("Reached unexpected end of file while reading;;;;")
         bytes=bytes-len(out)
         print "Read :"+str(len(out))
         #decrypt data before writing 
         i=0
         dec_out=""
         while(i<len(out)):
           dec_out=dec_out+chr(ord(out[i])^ord("k"));
           i=i+1;
         fd2.write(out) #assuming all bytes are written  
         fd2.flush()
         if(bytes==0):
              break;  
      off=off+enc_end-enc_start+1          

      last_end=enc_end

    return;



if(len(sys.argv) != 3):
    sys.exit("Usage src_file dest_directory\n");													

#read filesytem of each file

if os.path.isfile(sys.argv[1]) == False:
    sys.exit("Source must be a file\n");

if os.path.isdir(sys.argv[2]) == False:
    sys.exit("Dest must be a directory\n");


fs=[filesystem(sys.argv[1]),filesystem(sys.argv[2])];

if((fs[0].lower()=="usife") and (fs[1].lower()=="usife")):
   sys.exit("Error : both files can't be from usife file system\n");

elif(fs[0].lower()=="usife"):
   print "src from usife\n"
   copy_out(sys.argv[1],sys.argv[2])

elif(fs[1].lower()=="usife"):
   print "dst from usife\n"
   if(os.path.splitext(sys.argv[1])[1]!=".usife"):
     print "src file is of unsupported format"
   copy_in(sys.argv[1],sys.argv[2]) 

else:
   sys.exit("no file from usife\n")

    
